package general;

import java.io.Serializable;
import java.util.Date;

public class Packet implements Serializable
{
	private static final long serialVersionUID = 1L;

	public static final int MESSAGE = 0, LOGOUT = 2, CONTROL_MSG = 3, NEW_CLIENT = 5, FAILED = 6, CLIENT_LEFT = 7,
			NEW_HD = 8, HD_LEFT = 9, TRANSFER = 10, CONNECT = 11, DISCONNECT = 12;
	private int type;
	private int source, destination;
	private String data;
	private Date timeStamp;

	public Packet(int type, String data, Date date)
	{
		this.type = type;
		this.data = data;
		this.timeStamp = date;
	}

	public Packet(int type, int source, int destination, String data, Date date)
	{
		this.type = type;
		this.source = source;
		this.destination = destination;
		this.data = data;
		this.timeStamp = date;
	}

	public int getType()
	{
		return type;
	}

	public String getData()
	{
		return data;
	}

	public int getSource()
	{
		return source;
	}

	public int getDestination()
	{
		return destination;
	}
	
	public Date getTimeStamp()
	{
		return timeStamp;
	}
}
