package server;

import java.io.*;
import java.util.*;

public class PasswordInfo
{
	private String salt;
	private String hex;
	private long lastAttemptTime;
	private int failedAttemptsNum;
	private boolean found;
	private BufferedReader buffReader;

	public PasswordInfo(String username)
	{
		found = false;
		try
		{
			buffReader = new BufferedReader(new FileReader(new File("passwords.txt")));
			String line;
			while ((line = buffReader.readLine()) != null)
			{
				StringTokenizer tokens = new StringTokenizer(line, ":", true);
				if (username.equals(tokens.nextToken()))
				{
					tokens.nextToken();
					salt = tokens.nextToken();
					tokens.nextToken();
					hex = tokens.nextToken();
					found = true;
					break;
				}
			}
		} catch (IOException e)
		{
			found = false;
		}
		lastAttemptTime = System.currentTimeMillis();
		failedAttemptsNum = 0;
	}

	public boolean wasFound()
	{
		return found;
	}

	public String getSalt()
	{
		return salt;
	}

	public String getHex()
	{
		return hex;
	}

	public void failedAttempet()
	{
		failedAttemptsNum++;
		lastAttemptTime = System.currentTimeMillis();
	}

	public boolean isLocked()
	{
		if (System.currentTimeMillis() - lastAttemptTime >= 60 * 60 * 1000) //1 hr
		{
			failedAttemptsNum = 0;
		}
		if (failedAttemptsNum >= 5)
		{
			return true;
		}
		return false;
	}

}
