package server;

import javax.swing.*;
import javax.swing.border.EmptyBorder;
import java.awt.*;
import java.awt.event.*;

public class ServerGUI extends JFrame implements ActionListener
{
	private static final long serialVersionUID = 1L;
	private JPanel contentPane;
	private JTextField portText;
	private JTextArea log;
	private JButton start;
	private Server server;
	private JScrollPane scrolEvents;
	private JScrollPane scrolList;
	DefaultListModel listModel;
	private JList list;

	public static void main(String[] args)
	{
		new ServerGUI();
	}

	public ServerGUI()
	{
		super("Server");
		
		setBounds(100, 100, 490, 609);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);

		JLabel lblPortNumber = new JLabel("Port Number:");
		lblPortNumber.setFont(new Font("Tahoma", Font.BOLD, 12));
		lblPortNumber.setBounds(55, 11, 82, 30);
		contentPane.add(lblPortNumber);

		portText = new JTextField("2500");
		portText.setBounds(158, 17, 86, 20);
		contentPane.add(portText);
		portText.setColumns(10);

		start = new JButton("Start");
		start.addActionListener(this);
		start.setBounds(255, 16, 89, 23);
		contentPane.add(start);

		scrolEvents = new JScrollPane();
		scrolEvents.setBounds(10, 52, 381, 464);
		contentPane.add(scrolEvents);
		log = new JTextArea();
		scrolEvents.setViewportView(log);

		JLabel lblHelpdeskUsers = new JLabel("Help-Desk Users:");
		lblHelpdeskUsers.setBounds(405, 31, 100, 14);
		getContentPane().add(lblHelpdeskUsers);

		scrolList = new JScrollPane();
		scrolList.setBounds(401, 52, 104, 464);
		contentPane.add(scrolList);

		listModel = new DefaultListModel();
		list = new JList(listModel);
		list.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
		list.setLayoutOrientation(JList.VERTICAL);
		list.setVisibleRowCount(-1);
		scrolList.setViewportView(list);

		setSize(531, 566);
		setVisible(true);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	public void append(String str)
	{
		log.append(str + "\n\n");
		log.setCaretPosition(log.getText().length() - 1);
	}

	@Override
	public void actionPerformed(ActionEvent e)
	{
		if (start.getText() == "Start")
		{
			int port;
			try
			{
				port = Integer.parseInt(portText.getText().trim());
			} catch (Exception r)
			{
				append("Invalid port number.");
				return;
			}
			server = new Server(port, this);
			new Thread(server).start();
			start.setText("Stop");
			portText.setEditable(false);
		} else
		{
			try
			{
				server.done();
			} catch (Exception e1)
			{
				server.print("Exception on terminating the server: " + e1);
			}
			server = null;
		}
	}

	public void resetGUI()
	{
		start.setText("Start");
		portText.setEditable(true);
		listModel.clear();
		append("Server stopped working.\n");
	}
}
